// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from base2d_kinematics_msgs:msg/Base2DKinematics.idl
// generated code does not contain a copyright notice

#ifndef BASE2D_KINEMATICS_MSGS__MSG__DETAIL__BASE2_D_KINEMATICS__STRUCT_HPP_
#define BASE2D_KINEMATICS_MSGS__MSG__DETAIL__BASE2_D_KINEMATICS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__base2d_kinematics_msgs__msg__Base2DKinematics __attribute__((deprecated))
#else
# define DEPRECATED__base2d_kinematics_msgs__msg__Base2DKinematics __declspec(deprecated)
#endif

namespace base2d_kinematics_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Base2DKinematics_
{
  using Type = Base2DKinematics_<ContainerAllocator>;

  explicit Base2DKinematics_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->min_vel_x = 0.0;
      this->max_vel_x = 0.0;
      this->min_vel_y = 0.0;
      this->max_vel_y = 0.0;
      this->max_vel_theta = 0.0;
      this->acc_lim_x = 0.0;
      this->decel_lim_x = 0.0;
      this->acc_lim_y = 0.0;
      this->decel_lim_y = 0.0;
      this->acc_lim_theta = 0.0;
      this->decel_lim_theta = 0.0;
      this->min_speed_xy = 0.0;
      this->max_speed_xy = 0.0;
      this->min_speed_theta = 0.0;
    }
  }

  explicit Base2DKinematics_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->min_vel_x = 0.0;
      this->max_vel_x = 0.0;
      this->min_vel_y = 0.0;
      this->max_vel_y = 0.0;
      this->max_vel_theta = 0.0;
      this->acc_lim_x = 0.0;
      this->decel_lim_x = 0.0;
      this->acc_lim_y = 0.0;
      this->decel_lim_y = 0.0;
      this->acc_lim_theta = 0.0;
      this->decel_lim_theta = 0.0;
      this->min_speed_xy = 0.0;
      this->max_speed_xy = 0.0;
      this->min_speed_theta = 0.0;
    }
  }

  // field types and members
  using _min_vel_x_type =
    double;
  _min_vel_x_type min_vel_x;
  using _max_vel_x_type =
    double;
  _max_vel_x_type max_vel_x;
  using _min_vel_y_type =
    double;
  _min_vel_y_type min_vel_y;
  using _max_vel_y_type =
    double;
  _max_vel_y_type max_vel_y;
  using _max_vel_theta_type =
    double;
  _max_vel_theta_type max_vel_theta;
  using _acc_lim_x_type =
    double;
  _acc_lim_x_type acc_lim_x;
  using _decel_lim_x_type =
    double;
  _decel_lim_x_type decel_lim_x;
  using _acc_lim_y_type =
    double;
  _acc_lim_y_type acc_lim_y;
  using _decel_lim_y_type =
    double;
  _decel_lim_y_type decel_lim_y;
  using _acc_lim_theta_type =
    double;
  _acc_lim_theta_type acc_lim_theta;
  using _decel_lim_theta_type =
    double;
  _decel_lim_theta_type decel_lim_theta;
  using _min_speed_xy_type =
    double;
  _min_speed_xy_type min_speed_xy;
  using _max_speed_xy_type =
    double;
  _max_speed_xy_type max_speed_xy;
  using _min_speed_theta_type =
    double;
  _min_speed_theta_type min_speed_theta;

  // setters for named parameter idiom
  Type & set__min_vel_x(
    const double & _arg)
  {
    this->min_vel_x = _arg;
    return *this;
  }
  Type & set__max_vel_x(
    const double & _arg)
  {
    this->max_vel_x = _arg;
    return *this;
  }
  Type & set__min_vel_y(
    const double & _arg)
  {
    this->min_vel_y = _arg;
    return *this;
  }
  Type & set__max_vel_y(
    const double & _arg)
  {
    this->max_vel_y = _arg;
    return *this;
  }
  Type & set__max_vel_theta(
    const double & _arg)
  {
    this->max_vel_theta = _arg;
    return *this;
  }
  Type & set__acc_lim_x(
    const double & _arg)
  {
    this->acc_lim_x = _arg;
    return *this;
  }
  Type & set__decel_lim_x(
    const double & _arg)
  {
    this->decel_lim_x = _arg;
    return *this;
  }
  Type & set__acc_lim_y(
    const double & _arg)
  {
    this->acc_lim_y = _arg;
    return *this;
  }
  Type & set__decel_lim_y(
    const double & _arg)
  {
    this->decel_lim_y = _arg;
    return *this;
  }
  Type & set__acc_lim_theta(
    const double & _arg)
  {
    this->acc_lim_theta = _arg;
    return *this;
  }
  Type & set__decel_lim_theta(
    const double & _arg)
  {
    this->decel_lim_theta = _arg;
    return *this;
  }
  Type & set__min_speed_xy(
    const double & _arg)
  {
    this->min_speed_xy = _arg;
    return *this;
  }
  Type & set__max_speed_xy(
    const double & _arg)
  {
    this->max_speed_xy = _arg;
    return *this;
  }
  Type & set__min_speed_theta(
    const double & _arg)
  {
    this->min_speed_theta = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    base2d_kinematics_msgs::msg::Base2DKinematics_<ContainerAllocator> *;
  using ConstRawPtr =
    const base2d_kinematics_msgs::msg::Base2DKinematics_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<base2d_kinematics_msgs::msg::Base2DKinematics_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<base2d_kinematics_msgs::msg::Base2DKinematics_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      base2d_kinematics_msgs::msg::Base2DKinematics_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<base2d_kinematics_msgs::msg::Base2DKinematics_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      base2d_kinematics_msgs::msg::Base2DKinematics_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<base2d_kinematics_msgs::msg::Base2DKinematics_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<base2d_kinematics_msgs::msg::Base2DKinematics_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<base2d_kinematics_msgs::msg::Base2DKinematics_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__base2d_kinematics_msgs__msg__Base2DKinematics
    std::shared_ptr<base2d_kinematics_msgs::msg::Base2DKinematics_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__base2d_kinematics_msgs__msg__Base2DKinematics
    std::shared_ptr<base2d_kinematics_msgs::msg::Base2DKinematics_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Base2DKinematics_ & other) const
  {
    if (this->min_vel_x != other.min_vel_x) {
      return false;
    }
    if (this->max_vel_x != other.max_vel_x) {
      return false;
    }
    if (this->min_vel_y != other.min_vel_y) {
      return false;
    }
    if (this->max_vel_y != other.max_vel_y) {
      return false;
    }
    if (this->max_vel_theta != other.max_vel_theta) {
      return false;
    }
    if (this->acc_lim_x != other.acc_lim_x) {
      return false;
    }
    if (this->decel_lim_x != other.decel_lim_x) {
      return false;
    }
    if (this->acc_lim_y != other.acc_lim_y) {
      return false;
    }
    if (this->decel_lim_y != other.decel_lim_y) {
      return false;
    }
    if (this->acc_lim_theta != other.acc_lim_theta) {
      return false;
    }
    if (this->decel_lim_theta != other.decel_lim_theta) {
      return false;
    }
    if (this->min_speed_xy != other.min_speed_xy) {
      return false;
    }
    if (this->max_speed_xy != other.max_speed_xy) {
      return false;
    }
    if (this->min_speed_theta != other.min_speed_theta) {
      return false;
    }
    return true;
  }
  bool operator!=(const Base2DKinematics_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Base2DKinematics_

// alias to use template instance with default allocator
using Base2DKinematics =
  base2d_kinematics_msgs::msg::Base2DKinematics_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace base2d_kinematics_msgs

#endif  // BASE2D_KINEMATICS_MSGS__MSG__DETAIL__BASE2_D_KINEMATICS__STRUCT_HPP_
