// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from base2d_kinematics_msgs:msg/Base2DKinematics.idl
// generated code does not contain a copyright notice

#ifndef BASE2D_KINEMATICS_MSGS__MSG__DETAIL__BASE2_D_KINEMATICS__TRAITS_HPP_
#define BASE2D_KINEMATICS_MSGS__MSG__DETAIL__BASE2_D_KINEMATICS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "base2d_kinematics_msgs/msg/detail/base2_d_kinematics__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace base2d_kinematics_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Base2DKinematics & msg,
  std::ostream & out)
{
  out << "{";
  // member: min_vel_x
  {
    out << "min_vel_x: ";
    rosidl_generator_traits::value_to_yaml(msg.min_vel_x, out);
    out << ", ";
  }

  // member: max_vel_x
  {
    out << "max_vel_x: ";
    rosidl_generator_traits::value_to_yaml(msg.max_vel_x, out);
    out << ", ";
  }

  // member: min_vel_y
  {
    out << "min_vel_y: ";
    rosidl_generator_traits::value_to_yaml(msg.min_vel_y, out);
    out << ", ";
  }

  // member: max_vel_y
  {
    out << "max_vel_y: ";
    rosidl_generator_traits::value_to_yaml(msg.max_vel_y, out);
    out << ", ";
  }

  // member: max_vel_theta
  {
    out << "max_vel_theta: ";
    rosidl_generator_traits::value_to_yaml(msg.max_vel_theta, out);
    out << ", ";
  }

  // member: acc_lim_x
  {
    out << "acc_lim_x: ";
    rosidl_generator_traits::value_to_yaml(msg.acc_lim_x, out);
    out << ", ";
  }

  // member: decel_lim_x
  {
    out << "decel_lim_x: ";
    rosidl_generator_traits::value_to_yaml(msg.decel_lim_x, out);
    out << ", ";
  }

  // member: acc_lim_y
  {
    out << "acc_lim_y: ";
    rosidl_generator_traits::value_to_yaml(msg.acc_lim_y, out);
    out << ", ";
  }

  // member: decel_lim_y
  {
    out << "decel_lim_y: ";
    rosidl_generator_traits::value_to_yaml(msg.decel_lim_y, out);
    out << ", ";
  }

  // member: acc_lim_theta
  {
    out << "acc_lim_theta: ";
    rosidl_generator_traits::value_to_yaml(msg.acc_lim_theta, out);
    out << ", ";
  }

  // member: decel_lim_theta
  {
    out << "decel_lim_theta: ";
    rosidl_generator_traits::value_to_yaml(msg.decel_lim_theta, out);
    out << ", ";
  }

  // member: min_speed_xy
  {
    out << "min_speed_xy: ";
    rosidl_generator_traits::value_to_yaml(msg.min_speed_xy, out);
    out << ", ";
  }

  // member: max_speed_xy
  {
    out << "max_speed_xy: ";
    rosidl_generator_traits::value_to_yaml(msg.max_speed_xy, out);
    out << ", ";
  }

  // member: min_speed_theta
  {
    out << "min_speed_theta: ";
    rosidl_generator_traits::value_to_yaml(msg.min_speed_theta, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Base2DKinematics & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: min_vel_x
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "min_vel_x: ";
    rosidl_generator_traits::value_to_yaml(msg.min_vel_x, out);
    out << "\n";
  }

  // member: max_vel_x
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_vel_x: ";
    rosidl_generator_traits::value_to_yaml(msg.max_vel_x, out);
    out << "\n";
  }

  // member: min_vel_y
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "min_vel_y: ";
    rosidl_generator_traits::value_to_yaml(msg.min_vel_y, out);
    out << "\n";
  }

  // member: max_vel_y
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_vel_y: ";
    rosidl_generator_traits::value_to_yaml(msg.max_vel_y, out);
    out << "\n";
  }

  // member: max_vel_theta
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_vel_theta: ";
    rosidl_generator_traits::value_to_yaml(msg.max_vel_theta, out);
    out << "\n";
  }

  // member: acc_lim_x
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "acc_lim_x: ";
    rosidl_generator_traits::value_to_yaml(msg.acc_lim_x, out);
    out << "\n";
  }

  // member: decel_lim_x
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "decel_lim_x: ";
    rosidl_generator_traits::value_to_yaml(msg.decel_lim_x, out);
    out << "\n";
  }

  // member: acc_lim_y
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "acc_lim_y: ";
    rosidl_generator_traits::value_to_yaml(msg.acc_lim_y, out);
    out << "\n";
  }

  // member: decel_lim_y
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "decel_lim_y: ";
    rosidl_generator_traits::value_to_yaml(msg.decel_lim_y, out);
    out << "\n";
  }

  // member: acc_lim_theta
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "acc_lim_theta: ";
    rosidl_generator_traits::value_to_yaml(msg.acc_lim_theta, out);
    out << "\n";
  }

  // member: decel_lim_theta
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "decel_lim_theta: ";
    rosidl_generator_traits::value_to_yaml(msg.decel_lim_theta, out);
    out << "\n";
  }

  // member: min_speed_xy
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "min_speed_xy: ";
    rosidl_generator_traits::value_to_yaml(msg.min_speed_xy, out);
    out << "\n";
  }

  // member: max_speed_xy
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_speed_xy: ";
    rosidl_generator_traits::value_to_yaml(msg.max_speed_xy, out);
    out << "\n";
  }

  // member: min_speed_theta
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "min_speed_theta: ";
    rosidl_generator_traits::value_to_yaml(msg.min_speed_theta, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Base2DKinematics & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace base2d_kinematics_msgs

namespace rosidl_generator_traits
{

[[deprecated("use base2d_kinematics_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const base2d_kinematics_msgs::msg::Base2DKinematics & msg,
  std::ostream & out, size_t indentation = 0)
{
  base2d_kinematics_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use base2d_kinematics_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const base2d_kinematics_msgs::msg::Base2DKinematics & msg)
{
  return base2d_kinematics_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<base2d_kinematics_msgs::msg::Base2DKinematics>()
{
  return "base2d_kinematics_msgs::msg::Base2DKinematics";
}

template<>
inline const char * name<base2d_kinematics_msgs::msg::Base2DKinematics>()
{
  return "base2d_kinematics_msgs/msg/Base2DKinematics";
}

template<>
struct has_fixed_size<base2d_kinematics_msgs::msg::Base2DKinematics>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<base2d_kinematics_msgs::msg::Base2DKinematics>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<base2d_kinematics_msgs::msg::Base2DKinematics>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // BASE2D_KINEMATICS_MSGS__MSG__DETAIL__BASE2_D_KINEMATICS__TRAITS_HPP_
