// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from base2d_kinematics_msgs:msg/Base2DKinematics.idl
// generated code does not contain a copyright notice

#ifndef BASE2D_KINEMATICS_MSGS__MSG__DETAIL__BASE2_D_KINEMATICS__FUNCTIONS_H_
#define BASE2D_KINEMATICS_MSGS__MSG__DETAIL__BASE2_D_KINEMATICS__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "base2d_kinematics_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "base2d_kinematics_msgs/msg/detail/base2_d_kinematics__struct.h"

/// Initialize msg/Base2DKinematics message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * base2d_kinematics_msgs__msg__Base2DKinematics
 * )) before or use
 * base2d_kinematics_msgs__msg__Base2DKinematics__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_base2d_kinematics_msgs
bool
base2d_kinematics_msgs__msg__Base2DKinematics__init(base2d_kinematics_msgs__msg__Base2DKinematics * msg);

/// Finalize msg/Base2DKinematics message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_base2d_kinematics_msgs
void
base2d_kinematics_msgs__msg__Base2DKinematics__fini(base2d_kinematics_msgs__msg__Base2DKinematics * msg);

/// Create msg/Base2DKinematics message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * base2d_kinematics_msgs__msg__Base2DKinematics__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_base2d_kinematics_msgs
base2d_kinematics_msgs__msg__Base2DKinematics *
base2d_kinematics_msgs__msg__Base2DKinematics__create();

/// Destroy msg/Base2DKinematics message.
/**
 * It calls
 * base2d_kinematics_msgs__msg__Base2DKinematics__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_base2d_kinematics_msgs
void
base2d_kinematics_msgs__msg__Base2DKinematics__destroy(base2d_kinematics_msgs__msg__Base2DKinematics * msg);

/// Check for msg/Base2DKinematics message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_base2d_kinematics_msgs
bool
base2d_kinematics_msgs__msg__Base2DKinematics__are_equal(const base2d_kinematics_msgs__msg__Base2DKinematics * lhs, const base2d_kinematics_msgs__msg__Base2DKinematics * rhs);

/// Copy a msg/Base2DKinematics message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_base2d_kinematics_msgs
bool
base2d_kinematics_msgs__msg__Base2DKinematics__copy(
  const base2d_kinematics_msgs__msg__Base2DKinematics * input,
  base2d_kinematics_msgs__msg__Base2DKinematics * output);

/// Initialize array of msg/Base2DKinematics messages.
/**
 * It allocates the memory for the number of elements and calls
 * base2d_kinematics_msgs__msg__Base2DKinematics__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_base2d_kinematics_msgs
bool
base2d_kinematics_msgs__msg__Base2DKinematics__Sequence__init(base2d_kinematics_msgs__msg__Base2DKinematics__Sequence * array, size_t size);

/// Finalize array of msg/Base2DKinematics messages.
/**
 * It calls
 * base2d_kinematics_msgs__msg__Base2DKinematics__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_base2d_kinematics_msgs
void
base2d_kinematics_msgs__msg__Base2DKinematics__Sequence__fini(base2d_kinematics_msgs__msg__Base2DKinematics__Sequence * array);

/// Create array of msg/Base2DKinematics messages.
/**
 * It allocates the memory for the array and calls
 * base2d_kinematics_msgs__msg__Base2DKinematics__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_base2d_kinematics_msgs
base2d_kinematics_msgs__msg__Base2DKinematics__Sequence *
base2d_kinematics_msgs__msg__Base2DKinematics__Sequence__create(size_t size);

/// Destroy array of msg/Base2DKinematics messages.
/**
 * It calls
 * base2d_kinematics_msgs__msg__Base2DKinematics__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_base2d_kinematics_msgs
void
base2d_kinematics_msgs__msg__Base2DKinematics__Sequence__destroy(base2d_kinematics_msgs__msg__Base2DKinematics__Sequence * array);

/// Check for msg/Base2DKinematics message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_base2d_kinematics_msgs
bool
base2d_kinematics_msgs__msg__Base2DKinematics__Sequence__are_equal(const base2d_kinematics_msgs__msg__Base2DKinematics__Sequence * lhs, const base2d_kinematics_msgs__msg__Base2DKinematics__Sequence * rhs);

/// Copy an array of msg/Base2DKinematics messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_base2d_kinematics_msgs
bool
base2d_kinematics_msgs__msg__Base2DKinematics__Sequence__copy(
  const base2d_kinematics_msgs__msg__Base2DKinematics__Sequence * input,
  base2d_kinematics_msgs__msg__Base2DKinematics__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // BASE2D_KINEMATICS_MSGS__MSG__DETAIL__BASE2_D_KINEMATICS__FUNCTIONS_H_
