// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from base2d_kinematics_msgs:msg/Base2DKinematics.idl
// generated code does not contain a copyright notice

#ifndef BASE2D_KINEMATICS_MSGS__MSG__DETAIL__BASE2_D_KINEMATICS__STRUCT_H_
#define BASE2D_KINEMATICS_MSGS__MSG__DETAIL__BASE2_D_KINEMATICS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Struct defined in msg/Base2DKinematics in the package base2d_kinematics_msgs.
/**
  * Velocities
  * X & Y in meters / second
 */
typedef struct base2d_kinematics_msgs__msg__Base2DKinematics
{
  double min_vel_x;
  double max_vel_x;
  double min_vel_y;
  double max_vel_y;
  /// theta in radians / second
  /// The minimum rotational velocity is assumed to be -max_vel_theta
  /// i.e. can turn both ways equally
  double max_vel_theta;
  /// Acceleration
  /// X & Y in meters / second^2
  double acc_lim_x;
  double decel_lim_x;
  double acc_lim_y;
  double decel_lim_y;
  /// Theta in radians / second^2
  double acc_lim_theta;
  double decel_lim_theta;
  /// Speeds
  /// Limits for combined xy / translational velocity in meters / second
  /// Previously called min_trans_vel
  double min_speed_xy;
  /// Previously called max_trans_vel
  double max_speed_xy;
  /// The absolute value of the minimum rotational velocity in radians / second
  /// Previously called min_rot_vel
  double min_speed_theta;
} base2d_kinematics_msgs__msg__Base2DKinematics;

// Struct for a sequence of base2d_kinematics_msgs__msg__Base2DKinematics.
typedef struct base2d_kinematics_msgs__msg__Base2DKinematics__Sequence
{
  base2d_kinematics_msgs__msg__Base2DKinematics * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} base2d_kinematics_msgs__msg__Base2DKinematics__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // BASE2D_KINEMATICS_MSGS__MSG__DETAIL__BASE2_D_KINEMATICS__STRUCT_H_
